file = ReadFile("./settings.ini")
Global gx#=ReadLine(file)
Global gy#=ReadLine(file)
Global bit=ReadLine(file)
Global screen=ReadLine(file)
Global dbycol=ReadLine(file)
CloseFile file


AppTitle "Impo"
Graphics gx,gy,bit,screen

SetBuffer BackBuffer()
SeedRnd MilliSecs()


Global Timer = CreateTimer(60)
Global levelnr,objcount,startx=64,starty=64,deathcount,points,finish,lvlname$,checkx,checky
Global frame,fpstimer,fps

Global sx#=gx/1024
Global sy#=gy/768


;mapedit vars
Global ask,momt = 1,mx,my,mmx#,mmy#,name$,korx,kory

;----- Types----------
Type guy
Field x#,y#,speed#
End Type

Type enemy
Field x#,y#,speed#,wps,wpx[99],wpy[99],mwp
End Type

Type tile
Field x#,y#,Typ
End Type

Type obj
Field x#,y#
End Type


Dim map(32,24)

;-------------------------------------------


;--------------------------LOADING---------------------
Global tileset=LoadAnimImage("./gfx/tileset.png",32,32,0,4)
ScaleImage tileset,sx,sy
MaskImage tileset,255,0,255
Global guyimg=LoadImage("./gfx/guyimg.png")
ScaleImage guyimg,sx,sy
Global objimg=LoadImage("./gfx/objimg.png")
MaskImage objimg,255,0,255
ScaleImage objimg,sx,sy
Global enemyimg=LoadImage("./gfx/enemyimg.png")
MaskImage enemyimg,255,0,255
ScaleImage enemyimg,sx,sy
Global font=LoadFont("Comic Sans MS",24,1,0,0)
;-----------------------------------------------------
SetFont font

;------------------------------------------------------------------------------------------
;----------Uncomment this and the line in control() to activate the EDITOR------
;Include "mapeditor.bb"
;----------------------------------------------
;--------------------------------------------------

chooselevel()

Function loadgame()
g.guy = New guy
g\x=64*sx
g\y=64*sy
g\speed=4*sx

HidePointer

createlevel("1",1)

FlushKeys()
main()
End Function

;---------- MAIN Looooop-----------

Function main()
While Not KeyHit(1)
Cls
control()
draw()
showfpsfu()
WaitTimer(timer)
Flip
Wend
FlushKeys()
showpoints()
End Function



;-----------FUNCTIONS------------------

Function control()
For g.guy = Each guy

If KeyDown(205) Then ;right
If dbycol = 0 Then
If map((g\x+1)/(32*sx),(g\y-15*sy)/(32*sy)) <> 1 And map((g\x+1)/(32*sx),(g\y-1)/(32*sy)) <> 1 Then 
g\x = g\x + g\speed
EndIf
Else
g\x = g\x + g\speed
EndIf
EndIf

If KeyDown(203) Then ;left
If dbycol = 0 Then
If map((g\x-17*sx)/(32*sx),(g\y-15*sy)/(32*sy)) <> 1 And map((g\x-17*sx)/(32*sx),(g\y-1)/(32*sy)) <> 1 Then
g\x = g\x - g\speed
EndIf
Else
g\x = g\x - g\speed
EndIf
EndIf

If KeyDown(208) Then ;down
If dbycol = 0 Then
If map((g\x-15*sx)/(32*sx),(g\y+1)/(32*sy)) <> 1 And map((g\x-1)/(32*sx),(g\y+1)/(32*sy)) <> 1 Then
g\y = g\y + g\speed
EndIf
Else
g\y = g\y + g\speed
EndIf
EndIf

If KeyDown(200) Then ;up
If dbycol = 0 Then
If map((g\x-15*sx)/(32*sx),(g\y-17*sy)/(32*sy)) <> 1 And map((g\x-1)/(32*sx),(g\y-17*sy)/(32*sy)) <> 1 Then
g\y = g\y - g\speed
EndIf
Else
g\y = g\y - g\speed
EndIf
EndIf

For t.tile = Each tile
If ImagesCollide(guyimg,g\x,g\y,0,tileset,t\x,t\y,t\typ) Then
Select t\typ
Case 1 ;Wnde
If dbycol=1 Then
Death()
EndIf
Case 2 ;FINISH
ziel()
Case 3 ;checkpoint
checkx=t\x+8
checky=t\y+8
End Select
EndIf
Next

objcount=0
For o.obj = Each obj
If ImagesCollide(guyimg,g\x,g\y,0,objimg,o\x,o\y,0) Then
Delete o
points=points+100
EndIf
objcount=objcount+1
Next

For e.enemy = Each enemy
If ImagesCollide(guyimg,g\x,g\y,0,enemyimg,e\x,e\y,0) Then
Death()
Exit
EndIf

If e\x < e\wpx[e\mwp] Then
e\x=e\x+e\speed
ElseIf e\x > e\wpx[e\mwp]
e\x=e\x-e\speed
EndIf

If e\y < e\wpy[e\mwp] Then
e\y=e\y+e\speed
ElseIf e\y > e\wpy[e\mwp]
e\y=e\y-e\speed
EndIf

If e\x=e\wpx[e\mwp] And e\y=e\wpy[e\mwp] Then
If e\mwp=e\wps Then
e\mwp=1
Else
e\mwp=e\mwp+1
EndIf
EndIf


Next

If objcount=0 Then finish=1

;------------Uncomment this and the Include to activate the Editor-----------
;--------------------------------------------------------
;If KeyHit(50) Then mapedit_startmapedit()
;------------------------------------------------
;--------------------------------------------------

Next
End Function



Function Draw()
Color 255,255,255
For t.tile = Each tile
If t\typ<>0 Then
DrawImage tileset,t\x,t\y,t\typ
EndIf
Next
For o.obj = Each obj
DrawImage objimg,o\x,o\y,0
Next
For e.enemy = Each enemy
DrawImage enemyimg,e\x,e\y,0
Next
For g.guy = Each guy
DrawImage guyimg,g\x,g\y
Next
Text 0,16,"Level "+levelnr+" Deaths: "+deathcount,0,1
Text gx/2,16,"Punkte: "+points,1,1
Text gx-56,16,"FPS: "+fps,1,1
End Function


Function death()
For e.enemy = Each enemy
Delete e
Next
For t.tile = Each tile
Delete t
Next

createlevel("1",0)

For g.guy = Each guy
g\x=checkx
g\y=checky
deathcount=deathcount+1
Next
End Function

Function unload()
For e.enemy = Each enemy
Delete e
Next
For t.tile = Each tile
Delete t
Next
For g.guy = Each guy
Delete g
Next
For o.obj = Each obj
Delete o
Next
End Function



Function createlevel(levelname$,dot)
If levelname="1" Then
	If levelnr < 10 Then
		levelname$="level0"+levelnr
	Else
		levelname$="level"+levelnr
	EndIf
EndIf

If FileType("data\"+levelname$+".dat")=0 Then showpoints()

datei=ReadFile("data\"+levelname$+".dat")
For y=0 To 23
	For x=0 To 31
		map(x,y)=ReadLine(datei)
		createtile(x*32,y*32,map(x,y))
	Next
Next
CloseFile(datei)

datei=ReadFile("data\"+levelname$+".obj")
While Not Eof(datei)
	typ=ReadLine(datei)
	x=ReadLine(datei)
	y=ReadLine(datei)
	If typ = 6 Then
	e.enemy = New enemy
	e\x=x*32*sx
	e\y=y*32*sy
	e\mwp=1
	e\speed=ReadLine(datei)
	e\speed=e\speed*sx
	e\wps=ReadLine(datei)
	For i = 1 To e\wps Step 1
	wpx=ReadLine(datei)
	wpy=ReadLine(datei)
	e\wpx[i]=wpx*32*sx
	e\wpy[i]=wpy*32*sy
	Next
	EndIf
	
	If typ = 5 And dot=1 Then createdot(x*32,y*32)
	
	leerstelle=ReadLine(datei)
Wend
CloseFile(datei)
lvlname$=levelname$
End Function


Function createtile(x,y,typ)
t.tile = New tile
t\x=x*sx
t\y=y*sy
t\typ=typ
End Function

Function createdot(x,y)
o.obj = New obj
o\x=x*sx
o\y=y*sy
End Function

Function ziel()
If finish = 1 Then
levelnr=levelnr+1

For e.enemy = Each enemy
Delete e
Next
For o.obj = Each obj
Delete o
Next
For t.tile = Each tile
Delete t
Next

createlevel("1",1)

For g.guy = Each guy
g\x=startx*sx
g\y=starty*sy
finish=0
Next

EndIf
End Function

Function showfpsfu()
If MilliSecs() < fpstimer+1000 Then
frame = frame + 1
Else
fps = frame
frame = 0
fpstimer = MilliSecs()
EndIf
End Function

Function chooselevel()
choosenr=levelnr
scrolly=levelnr*50
FlushKeys()
While Not KeyHit(1)
	Cls
	Text gx/2,20,"Whle das Level",1,1
	filedir=ReadDir(".\data\")
	nr=0
	
	Repeat
		temploc=Instr(file$,".dat",1)
		If temploc <> 0 Then
			nr=nr+1
			Text gx/2,gy/2+(50*nr)-scrolly+8-50,file$,1,1
		EndIf
		file$=NextFile(filedir)
		If file$="" Then Exit
	Forever
	CloseDir profdir
	If KeyHit(205) Then levelnr=choosenr : loadgame()
	If KeyHit(208) Then scrolly=scrolly+50 : choosenr=choosenr+1 ElseIf choosenr=nr Then choosenr=0 : scrolly=0
	If KeyHit(200) Then scrolly=scrolly-50 : choosenr=choosenr-1 ElseIf choosenr=-1 Then choosenr=nr-1 : scrolly=50*(nr-1)
	DrawImage guyimg,gx/2-100,gy/2 : DrawImage guyimg,gx/2+100,gy/2
	WaitTimer(timer)
	Flip
Wend
End
End Function

Function showpoints()
FlushKeys()
Repeat
Cls
Text gx/2,gy/2,"DEINE PUNKTZAHL:"+points ,1,1
WaitTimer(timer)
Flip
Until KeyHit(200) Or KeyHit(208) Or KeyHit(205) Or KeyHit(203) Or KeyHit(1)
points=0
unload()
chooselevel()
End Function